-- -------------------------------------------------------------
-- 
-- File Name: hdlsrc\System_Template\MATLAB_Function_FixPt.vhd
-- Created: 2021-09-30 12:46:01
-- 
-- Generated by MATLAB 9.11 and HDL Coder 3.19
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: MATLAB_Function_FixPt
-- Source Path: System_Template/DSP/MATLAB Function/MATLAB Function_FixPt
-- Hierarchy Level: 2
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY MATLAB_Function_FixPt IS
  PORT( Clk                               :   IN    std_logic;
        Reset                             :   IN    std_logic;
        InputA                            :   IN    signed(15 DOWNTO 0);  -- int16
        OutputA                           :   OUT   unsigned(15 DOWNTO 0)  -- uint16
        );
END MATLAB_Function_FixPt;


ARCHITECTURE rtl OF MATLAB_Function_FixPt IS

  -- Signals
  SIGNAL out0                             : unsigned(15 DOWNTO 0);  -- ufix16
  SIGNAL out0_next                        : unsigned(15 DOWNTO 0);  -- ufix16

BEGIN
  MATLAB_Function_FixPt_1_process : PROCESS (Clk)
  BEGIN
    IF Clk'EVENT AND Clk = '1' THEN
      IF Reset = '1' THEN
        out0 <= to_unsigned(16#0000#, 16);
      ELSE 
        out0 <= out0_next;
      END IF;
    END IF;
  END PROCESS MATLAB_Function_FixPt_1_process;

  MATLAB_Function_FixPt_1_output : PROCESS (InputA, out0)
    VARIABLE InputA1 : signed(15 DOWNTO 0);
    VARIABLE out0_temp : unsigned(15 DOWNTO 0);
  BEGIN
    out0_temp := out0;
    --auto-generated
    InputA1 := InputA(14 DOWNTO 0) & '0';
    --Retains variable value between function calls.
    --Set the upper threshold to 1/10 of the full positive range.
    --Set the lower threshold to 1/10 of the full negative range.
    IF InputA1 & '0' & '0' & '0' > to_signed(16#0CCC0#, 19) THEN 
      --Logic to perform the Schmitt trigger function.
      out0_temp := to_unsigned(16#7FFF#, 16);
      --Map to the highest positive number.
    ELSIF InputA1 & '0' & '0' < to_signed(-16#06660#, 18) THEN 
      out0_temp := to_unsigned(16#0000#, 16);
    END IF;
    --Assign variable out0 to OutputA.
    OutputA <= out0_temp;
    out0_next <= out0_temp;
  END PROCESS MATLAB_Function_FixPt_1_output;


END rtl;

